package ar.edu.unju.fi.poo.mavenJUnit5;

import static org.junit.jupiter.api.Assertions.*;

import java.util.List;

import org.apache.log4j.Logger;
import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.RepeatedTest;
import org.junit.jupiter.api.Tag;
import org.junit.jupiter.api.Test;


import ar.edu.unju.fi.poo.mavenJUnit5.dominio.Alumno;
import ar.edu.unju.fi.poo.mavenJUnit5.manager.AlumnoManager;


@DisplayName("Manager Alumnos")
class AlumnoManagerTestCase {
	final static Logger logger = Logger.getLogger(AlumnoManagerTestCase.class);
	
	static AlumnoManager target;  
	static Alumno alumno;
	static Alumno alumno2;
	static Alumno alumno3;
	
	@BeforeAll
	static void setUpBeforeClass() throws Exception {

	}

	@AfterAll
	static void tearDownAfterClass() throws Exception {

	}

	@BeforeEach
	void setUp() throws Exception {
		logger.debug("Configurando en SetUp...");
		logger.info("Configurando en SetUp...");
		logger.error("Configurando en SetUp...");
		target = new AlumnoManager();
		alumno = new Alumno(1,"AAAA");
		alumno2 = new Alumno(2,"BBBB");
		alumno3 = new Alumno(3,"CCCC");				
	}

	@AfterEach
	void tearDown() throws Exception {
		System.out.println("Limpiando variables...");
		target = null;
		alumno = null;
		alumno2 = null;
		alumno3 = null;				
	}

	@Test
	@DisplayName("Agregar Alumno")
	void agregarAlumnoTest() {
		System.out.println("Iniciando prueba de AgregarAlumno...");		
		target.agregarAlumno(alumno);
		Alumno alumnoBuscado = target.buscar("AAAA");
		assertNotNull(alumnoBuscado);
		target.eliminarAlumno(alumnoBuscado);
		Alumno alumnoBuscadoII = target.buscar("AAAA");
		assertNull(alumnoBuscadoII);
	}
	
	@Test
	@DisplayName("Eliminar Alumno")
	void agregaAlumnoTest() {
		System.out.println("Iniciando prueba de Eliminar...");		
		target.agregarAlumno(alumno);
		Alumno alumnoBuscado = target.buscar("AAAA");
		assertNotNull(alumnoBuscado);
		target.eliminarAlumno(alumnoBuscado);
		Alumno alumnoBuscadoII = target.buscar("AAAA");
		assertNull(alumnoBuscadoII);
	}
	
	@Test
	@DisplayName("Listar Activos")	
	@Disabled
	void listaActivosTest() {
		System.out.println("Iniciando prueba de Listar Activos...");		
		target.agregarAlumno(alumno);
		target.agregarAlumno(alumno2);
		target.agregarAlumno(alumno3);
		List<Alumno> lista = target.listarActivos();
		assertEquals(lista.size(), 3);
		alumno2.setEstado(Boolean.FALSE);
		lista = target.listarActivos();
		assertEquals(lista.size(), 2);
		
	}

}
